(**************************************************************************)
(*  The CDuce interpreter                                                 *)
(*  Alain.Frisch@ens.fr                                                   *)
(*  Copyright 2003 (see LICENSE for details)                              *)
(**************************************************************************)

module type T = 
sig
  type t  
    (* Hashtbl.hash'able and Pervasives.compare'able type;
       typically, t is an integer *)
  type value
    
  val clear: unit -> unit  
    (* Previously allocated symbols are no longer valid; no check
       is provided. Registered values can be released by the GC only after
       a call to clear. *)

  val mk: value -> t
  val dummy_min: t
  val dummy_max: t
    (* Two dummy symbols, not associated with any registered value;
       resp. smallest and largest than any other symbol *)

  val value: t -> value

  val compare: t -> t -> int
  val hash: t -> int
  val equal: t -> t -> bool
end

module Make(H : Hashtbl.HashedType) : T with type value = H.t and type t = int

