
class schema_extension :
  object ('a)
    method base : string
    method clone : 'a
    method default : string
    method find_attributes : schema_extension Pxp_document.node list
    method find_complexType : string -> schema_extension Pxp_document.node
    method find_facets : schema_extension Pxp_document.node list
    method find_global_attribute : string -> schema_extension Pxp_document.node
    method find_global_element : string -> schema_extension Pxp_document.node
    method find_simpleType : string -> schema_extension Pxp_document.node
    method find_term : schema_extension Pxp_document.node
    method find_terms : schema_extension Pxp_document.node list
    method fixed : string
    method has_attribute : string -> bool
    method has_element : string -> bool
    method has_no_term : bool
    method maxOccurs : string
    method minOccurs : string
    method mixed : bool
    method name : string
    method node : schema_extension Pxp_document.node
    method nth_element : int -> schema_extension Pxp_document.node
    method prohibited : bool
    method ref : string
    method required : bool
    method set_node : schema_extension Pxp_document.node -> unit
    method sub_elements : schema_extension Pxp_document.node list
    method typ : string
    method value : string
  end

val pxp_tree_of : string -> schema_extension Pxp_document.document
val pxp_stream_of_file : string -> Pxp_yacc.event Stream.t
val pxp_stream_of_value : Value.t -> Pxp_yacc.event Stream.t

  (* misc stuff *)

val string_of_pxp_event : Pxp_yacc.event -> string

val collect_pcdata : Pxp_yacc.event Stream.t -> string

  (** @raise Stream.Failure at the end of the stream *)
val peek : Pxp_yacc.event Stream.t -> Pxp_yacc.event

  (* debugging only *)
val dump_stream : Pxp_yacc.event Stream.t -> unit

