(* To test PXP pull parsers *)

open Pxp_yacc
open Pxp_lexer_types
open Pxp_types

let parse s =
  let config = { default_config with encoding = `Enc_utf8 } in
  let mgr = create_entity_manager config (from_file s) in
  let next_event = 
    create_pull_parser config (`Entry_document [`Extend_dtd_fully]) mgr in
  let event = ref (Some E_end_of_stream) in
  while !event <> None do
    event := next_event();
  done
;;


let () = parse Sys.argv.(1);;
