open Encodings

type v
val value: v -> Ns.qname  (* Get rid of that ... *)
val mk: Ns.t -> Utf8.t -> v
val mk_ascii: string -> v
val print_v: Format.formatter -> v -> unit
val vcompare: v -> v -> int
val vhash: v -> int
val vprint: Format.formatter -> v -> unit


type t
val hash: int -> t -> int
val equal: t -> t -> bool
val compare: t -> t -> int
val print : t -> (Format.formatter -> unit) list

val empty : t
val any   : t

val cup : t -> t -> t
val cap : t -> t -> t
val diff : t -> t -> t
val atom : v -> t
val any_in_ns : Ns.t -> t

val contains : v -> t -> bool
val disjoint : t -> t -> bool
val is_empty : t -> bool
val print_tag : t -> (Format.formatter -> unit) option


type 'a map
val mk_map: (t * 'a) list -> 'a map
val get_map: v -> 'a map -> 'a

