(**************************************************************************)
(*  The CDuce interpreter                                                 *)
(*  Alain.Frisch@ens.fr                                                   *)
(*  Copyright 2003 (see LICENSE for details)                              *)
(**************************************************************************)

let pos_int = Types.interval (Intervals.right (Intervals.mk "1"))
let non_neg_int = Types.interval (Intervals.right (Intervals.mk "0"))
let neg_int = Types.interval (Intervals.left (Intervals.mk "-1"))
let non_pos_int = Types.interval (Intervals.left (Intervals.mk "0"))

let pos_intstr =
  Sequence.plus (Types.char (Chars.char_class
			       (Chars.mk_char '0')
			       (Chars.mk_char '9')
			    )
		)

let neg_intstr =
  Types.times 
    (Types.cons (Types.char (Chars.atom (Chars.mk_char '-'))))
    (Types.cons pos_intstr)

let intstr = Types.cup pos_intstr neg_intstr  (* [ '-'? '0'--'9'+ ] *)

let true_atom = Atoms.mk_ascii "true"
let false_atom = Atoms.mk_ascii "false"
let true_type = Types.atom (Atoms.atom true_atom)
let false_type = Types.atom (Atoms.atom false_atom)

let bool = Types.cup true_type false_type
let nil = Sequence.nil_type
let string = Sequence.string
let any = Types.any
let int = Types.Int.any
let atom = Types.atom Atoms.any

let char_latin1 = Types.char (Chars.mk_classes [ (0,255) ])
let string_latin1 = Sequence.star char_latin1
