type v
val mk_int: int -> v
val mk_char: char -> v
val to_int: v -> int
val to_char: v -> char
val print_v : Format.formatter -> v -> unit
val print_v_in_string : Format.formatter -> v -> unit
val vcompare: v -> v -> int
val vhash: v -> int

type t (* = (Unichar.t * Unichar.t) list *)
val equal : t -> t -> bool
val hash  : int -> t -> int
val print : t -> (Format.formatter -> unit) list
val compare : t -> t -> int

val empty : t
val any   : t
val cup   : t -> t -> t
val cap   : t -> t -> t
val diff  : t -> t -> t
val char_class  : v -> v -> t
val atom  : v -> t
val mk_classes : (int * int) list -> t

val disjoint : t -> t -> bool
val is_empty : t -> bool
val contains : v -> t -> bool
val sample : t -> v
val is_char : t -> v option


type 'a map
val mk_map: (t * 'a) list -> 'a map
val get_map: v -> 'a map -> 'a
