(**************************************************************************)
(*  The CDuce interpreter                                                 *)
(*  Alain.Frisch@ens.fr                                                   *)
(*  Copyright 2003 (see LICENSE for details)                              *)
(**************************************************************************)

module U = Encodings.Utf8
module Id = Pool.Make(U)
module IdSet = SortedList.Make(SortedList.Lift(Id))
module IdMap = IdSet.Map
module Env = Map.Make(Id)
type id = Id.t
type 'a id_map = (unit,'a) IdMap.map
type fv = unit IdSet.t

let ident = Id.mk


module Label = struct
  type t = Ns.qname
  let equal (ns1,l1) (ns2,l2) = (Ns.equal ns1 ns2) && (U.equal l1 l2)
  let hash (ns,l) = Ns.hash ns + 17 * U.hash l
  let to_string x = Ns.InternalPrinter.attr x
  let print ppf x = Format.fprintf ppf "%s" (to_string x)
end

module LabelPool = Pool.Make(Label)
module LabelSet = SortedList.Make(SortedList.Lift(LabelPool))
module LabelMap = LabelSet.Map

type label = LabelPool.t
type 'a label_map = (unit,'a) LabelMap.map
