type v
val print_v : Format.formatter -> v -> unit
val mk: string -> v

val is_int: v -> bool
val get_int: v -> int

val vcompare: v -> v -> int
val vhash: v -> int

val vadd: v -> v -> v
val vmult: v -> v -> v
val vsub: v -> v -> v
val vdiv: v -> v -> v
val vmod: v -> v -> v


type t
val equal : t -> t -> bool
val hash  : int -> t -> int
val print : t -> (Format.formatter -> unit) list
val compare : t -> t -> int

val empty : t
val any   : t
val cup   : t -> t -> t
val cap   : t -> t -> t
val diff  : t -> t -> t

  (** closed interval *)
val bounded  : v -> v -> t

  (** left opened interval (i.e. * -- something ) *)
val left : v -> t

  (** right opened interval (i.e. something -- * ) *)
val right : v -> t

val atom : v -> t

val disjoint : t -> t -> bool
val is_empty : t -> bool
val contains : v -> t -> bool
val sample : t -> v


val add : t -> t -> t
val sub : t -> t -> t
val negat : t -> t
