val nil_type: Types.descr
val nil_atom: Atoms.v
val any: Types.descr
val seqseq: Types.descr
val string: Types.descr

val concat: Types.descr -> Types.descr -> Types.descr
val flatten: Types.descr -> Types.descr
val map: (Types.descr -> Types.descr) -> Types.descr -> Types.descr

val map_tree: 
  (Types.descr -> Types.descr * Types.descr) -> Types.descr -> Types.descr
 (* input type -> (result, residual) *)         (* sequence type *)

val star: Types.descr -> Types.descr
  (* For a type t, returns [t*] *)
val plus: Types.descr -> Types.descr

val approx: Types.descr -> Types.descr
  (*  For a type t <= [Any*], returns the least type s such that:
      t <= [s*]
      
      In general, for an arbitrary type, returns the least type s such that:
      t <= (X where X = (s, X) |  Any \ (Any,Any))
  *)

  (** given a list of descrs create the sequence type from them *)
val seq_of_list: Types.descr list -> Types.descr

